# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# python 2 and python 3 compatibility library
from six import iteritems

from apprendaapipythonclient.configuration import Configuration
from apprendaapipythonclient.api_client import ApiClient


class VersionsApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def versions_delete(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_delete(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_delete_with_http_info(alias, sub_alias, **kwargs)
        else:
            (data) = self.versions_delete_with_http_info(alias, sub_alias, **kwargs)
            return data

    def versions_delete_with_http_info(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_delete_with_http_info(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_delete`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_delete`")


        collection_formats = {}

        resource_path = '/api/v1/Versions'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'alias' in params:
            query_params['alias'] = params['alias']
        if 'sub_alias' in params:
            query_params['subAlias'] = params['sub_alias']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='object',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_delete_by_alias(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_delete_by_alias(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_delete_by_alias_with_http_info(alias, sub_alias, **kwargs)
        else:
            (data) = self.versions_delete_by_alias_with_http_info(alias, sub_alias, **kwargs)
            return data

    def versions_delete_by_alias_with_http_info(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_delete_by_alias_with_http_info(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_delete_by_alias" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_delete_by_alias`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_delete_by_alias`")


        collection_formats = {}

        resource_path = '/api/v1/Versions/{alias}/{subAlias}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='object',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_get(self, id, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :return: list[Version]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_get_with_http_info(id, **kwargs)
        else:
            (data) = self.versions_get_with_http_info(id, **kwargs)
            return data

    def versions_get_with_http_info(self, id, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get_with_http_info(id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :return: list[Version]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `versions_get`")


        collection_formats = {}

        resource_path = '/api/v1/Versions/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[Version]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_get_all(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get_all(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: EnrichedVersion
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_get_all_with_http_info(alias, sub_alias, **kwargs)
        else:
            (data) = self.versions_get_all_with_http_info(alias, sub_alias, **kwargs)
            return data

    def versions_get_all_with_http_info(self, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get_all_with_http_info(alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: EnrichedVersion
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_get_all" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_get_all`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_get_all`")


        collection_formats = {}

        resource_path = '/api/v1/Versions'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'alias' in params:
            query_params['alias'] = params['alias']
        if 'sub_alias' in params:
            query_params['subAlias'] = params['sub_alias']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='EnrichedVersion',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_get_by_alias(self, id, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get_by_alias(id, alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: list[Version]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_get_by_alias_with_http_info(id, alias, sub_alias, **kwargs)
        else:
            (data) = self.versions_get_by_alias_with_http_info(id, alias, sub_alias, **kwargs)
            return data

    def versions_get_by_alias_with_http_info(self, id, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get_by_alias_with_http_info(id, alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: list[Version]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'alias', 'sub_alias']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_get_by_alias" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `versions_get_by_alias`")
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_get_by_alias`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_get_by_alias`")


        collection_formats = {}

        resource_path = '/api/v1/Versions/{alias}/{subAlias}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']

        query_params = {}
        if 'id' in params:
            query_params['id'] = params['id']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[Version]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_get_by_identifier(self, alias, sub_alias, identifier, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get_by_identifier(alias, sub_alias, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :return: ByteArrayContent
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_get_by_identifier_with_http_info(alias, sub_alias, identifier, **kwargs)
        else:
            (data) = self.versions_get_by_identifier_with_http_info(alias, sub_alias, identifier, **kwargs)
            return data

    def versions_get_by_identifier_with_http_info(self, alias, sub_alias, identifier, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_get_by_identifier_with_http_info(alias, sub_alias, identifier, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param str identifier: (required)
        :return: ByteArrayContent
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'identifier']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_get_by_identifier" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_get_by_identifier`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_get_by_identifier`")
        # verify the required parameter 'identifier' is set
        if ('identifier' not in params) or (params['identifier'] is None):
            raise ValueError("Missing the required parameter `identifier` when calling `versions_get_by_identifier`")


        collection_formats = {}

        resource_path = '/api/v1/Versions/{alias}/{subAlias}/{identifier}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']
        if 'identifier' in params:
            path_params['identifier'] = params['identifier']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json', 'text/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='ByteArrayContent',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_post(self, id, version, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_post(id, version, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param Version version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_post_with_http_info(id, version, **kwargs)
        else:
            (data) = self.versions_post_with_http_info(id, version, **kwargs)
            return data

    def versions_post_with_http_info(self, id, version, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_post_with_http_info(id, version, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param Version version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'version']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `versions_post`")
        # verify the required parameter 'version' is set
        if ('version' not in params) or (params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `versions_post`")


        collection_formats = {}

        resource_path = '/api/v1/Versions/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'version' in params:
            body_params = params['version']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_post_by_id(self, id, version, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_post_by_id(id, version, alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param Version version: (required)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_post_by_id_with_http_info(id, version, alias, sub_alias, **kwargs)
        else:
            (data) = self.versions_post_by_id_with_http_info(id, version, alias, sub_alias, **kwargs)
            return data

    def versions_post_by_id_with_http_info(self, id, version, alias, sub_alias, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_post_by_id_with_http_info(id, version, alias, sub_alias, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str id: (required)
        :param Version version: (required)
        :param str alias: (required)
        :param str sub_alias: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'version', 'alias', 'sub_alias']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_post_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `versions_post_by_id`")
        # verify the required parameter 'version' is set
        if ('version' not in params) or (params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `versions_post_by_id`")
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_post_by_id`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_post_by_id`")


        collection_formats = {}

        resource_path = '/api/v1/Versions/{alias}/{subAlias}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']

        query_params = {}
        if 'id' in params:
            query_params['id'] = params['id']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'version' in params:
            body_params = params['version']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_post_by_sub_alias(self, alias, sub_alias, set_maintenance_off, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_post_by_sub_alias(alias, sub_alias, set_maintenance_off, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param bool set_maintenance_off: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_post_by_sub_alias_with_http_info(alias, sub_alias, set_maintenance_off, **kwargs)
        else:
            (data) = self.versions_post_by_sub_alias_with_http_info(alias, sub_alias, set_maintenance_off, **kwargs)
            return data

    def versions_post_by_sub_alias_with_http_info(self, alias, sub_alias, set_maintenance_off, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_post_by_sub_alias_with_http_info(alias, sub_alias, set_maintenance_off, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param bool set_maintenance_off: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'set_maintenance_off']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_post_by_sub_alias" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_post_by_sub_alias`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_post_by_sub_alias`")
        # verify the required parameter 'set_maintenance_off' is set
        if ('set_maintenance_off' not in params) or (params['set_maintenance_off'] is None):
            raise ValueError("Missing the required parameter `set_maintenance_off` when calling `versions_post_by_sub_alias`")


        collection_formats = {}

        resource_path = '/api/v1/Versions'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'alias' in params:
            query_params['alias'] = params['alias']
        if 'sub_alias' in params:
            query_params['subAlias'] = params['sub_alias']
        if 'set_maintenance_off' in params:
            query_params['setMaintenanceOff'] = params['set_maintenance_off']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_put(self, alias, sub_alias, version, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_put(alias, sub_alias, version, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param Version version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_put_with_http_info(alias, sub_alias, version, **kwargs)
        else:
            (data) = self.versions_put_with_http_info(alias, sub_alias, version, **kwargs)
            return data

    def versions_put_with_http_info(self, alias, sub_alias, version, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_put_with_http_info(alias, sub_alias, version, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param Version version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'version']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_put`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_put`")
        # verify the required parameter 'version' is set
        if ('version' not in params) or (params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `versions_put`")


        collection_formats = {}

        resource_path = '/api/v1/Versions'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'alias' in params:
            query_params['alias'] = params['alias']
        if 'sub_alias' in params:
            query_params['subAlias'] = params['sub_alias']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'version' in params:
            body_params = params['version']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def versions_put_into_alias(self, alias, sub_alias, version, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_put_into_alias(alias, sub_alias, version, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param Version version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.versions_put_into_alias_with_http_info(alias, sub_alias, version, **kwargs)
        else:
            (data) = self.versions_put_into_alias_with_http_info(alias, sub_alias, version, **kwargs)
            return data

    def versions_put_into_alias_with_http_info(self, alias, sub_alias, version, **kwargs):
        """
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.versions_put_into_alias_with_http_info(alias, sub_alias, version, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str alias: (required)
        :param str sub_alias: (required)
        :param Version version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['alias', 'sub_alias', 'version']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method versions_put_into_alias" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'alias' is set
        if ('alias' not in params) or (params['alias'] is None):
            raise ValueError("Missing the required parameter `alias` when calling `versions_put_into_alias`")
        # verify the required parameter 'sub_alias' is set
        if ('sub_alias' not in params) or (params['sub_alias'] is None):
            raise ValueError("Missing the required parameter `sub_alias` when calling `versions_put_into_alias`")
        # verify the required parameter 'version' is set
        if ('version' not in params) or (params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `versions_put_into_alias`")


        collection_formats = {}

        resource_path = '/api/v1/Versions/{alias}/{subAlias}'.replace('{format}', 'json')
        path_params = {}
        if 'alias' in params:
            path_params['alias'] = params['alias']
        if 'sub_alias' in params:
            path_params['subAlias'] = params['sub_alias']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'version' in params:
            body_params = params['version']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/json', 'application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
