# coding: utf-8

"""
    Account Management REST API

    The Account Management REST API can be used to manage user accounts, roles, and securables for applications on the Platform. The endpoints of this API allow you to perform the same the functionality of the Platform's Account Portal for your Tenant's applications.   For more information, see our documentation on the [Account Portal](/current/account).     ## Authentication    Before making a request, you must be authenticated. Follow these instuctions [to get authenticated](/restapi/accountmanagement/v1/authentication). ## Making a Request   ### Prerequisites    * Installed Platform of version 6.6.0 or later    * An active user account assigned to an active Tenant Account or Developer Team    * Authentication token   ### Request URL    All requests must use **https**.       The URL for every request you make is the URL of your Platform followed by \"/account\" and the path structure of the endpoint. For example, if your Platform URL is https://apps.apprenda.harp and you want to get a list of all user accounts for your Tenant, the request URL will be https://apps.apprenda.harp/account/api/v1/users.     For more information, see our documentation on [using api resources](/restapi/accountmanagement/v1/using-resources) and [finding your Cloud URI](/current/clouduri).    ### Request Headers  Your authenication token must be passed in the header of all requests using the key **ApprendaSessionToken** (not case sensitive).    

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import models into model package
from .application_version import ApplicationVersion
from .paged_resource_base_application_version import PagedResourceBaseApplicationVersion
from .paged_resource_base_user import PagedResourceBaseUser
from .plan import Plan
from .plan_request import PlanRequest
from .resource_base import ResourceBase
from .role import Role
from .securable import Securable
from .subscription import Subscription
from .subscription_request import SubscriptionRequest
from .unpaged_resource_base_plan import UnpagedResourceBasePlan
from .unpaged_resource_base_role import UnpagedResourceBaseRole
from .unpaged_resource_base_securable import UnpagedResourceBaseSecurable
from .unpaged_resource_base_subscription import UnpagedResourceBaseSubscription
from .unpaged_resource_base_user import UnpagedResourceBaseUser
from .upgrade_status import UpgradeStatus
from .user import User
