# coding: utf-8

"""
    Account Management REST API

    The Account Management REST API can be used to manage user accounts, roles, and securables for applications on the Platform. The endpoints of this API allow you to perform the same the functionality of the Platform's Account Portal for your Tenant's applications.   For more information, see our documentation on the [Account Portal](/current/account).     ## Authentication    Before making a request, you must be authenticated. Follow these instuctions [to get authenticated](/restapi/accountmanagement/v1/authentication). ## Making a Request   ### Prerequisites    * Installed Platform of version 6.6.0 or later    * An active user account assigned to an active Tenant Account or Developer Team    * Authentication token   ### Request URL    All requests must use **https**.       The URL for every request you make is the URL of your Platform followed by \"/account\" and the path structure of the endpoint. For example, if your Platform URL is https://apps.apprenda.harp and you want to get a list of all user accounts for your Tenant, the request URL will be https://apps.apprenda.harp/account/api/v1/users.     For more information, see our documentation on [using api resources](/restapi/accountmanagement/v1/using-resources) and [finding your Cloud URI](/current/clouduri).    ### Request Headers  Your authenication token must be passed in the header of all requests using the key **ApprendaSessionToken** (not case sensitive).    

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Securable(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, application_version=None, href=None, is_runtime=False, id=None, name=None, roles=None):
        """
        Securable - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'application_version': 'ResourceBase',
            'href': 'str',
            'is_runtime': 'bool',
            'id': 'str',
            'name': 'str',
            'roles': 'list[ResourceBase]'
        }

        self.attribute_map = {
            'application_version': 'applicationVersion',
            'href': 'href',
            'is_runtime': 'isRuntime',
            'id': 'id',
            'name': 'name',
            'roles': 'roles'
        }

        self._application_version = application_version
        self._href = href
        self._is_runtime = is_runtime
        self._id = id
        self._name = name
        self._roles = roles

    @property
    def application_version(self):
        """
        Gets the application_version of this Securable.

        :return: The application_version of this Securable.
        :rtype: ResourceBase
        """
        return self._application_version

    @application_version.setter
    def application_version(self, application_version):
        """
        Sets the application_version of this Securable.

        :param application_version: The application_version of this Securable.
        :type: ResourceBase
        """

        self._application_version = application_version

    @property
    def href(self):
        """
        Gets the href of this Securable.

        :return: The href of this Securable.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this Securable.

        :param href: The href of this Securable.
        :type: str
        """

        self._href = href

    @property
    def is_runtime(self):
        """
        Gets the is_runtime of this Securable.

        :return: The is_runtime of this Securable.
        :rtype: bool
        """
        return self._is_runtime

    @is_runtime.setter
    def is_runtime(self, is_runtime):
        """
        Sets the is_runtime of this Securable.

        :param is_runtime: The is_runtime of this Securable.
        :type: bool
        """

        self._is_runtime = is_runtime

    @property
    def id(self):
        """
        Gets the id of this Securable.

        :return: The id of this Securable.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Securable.

        :param id: The id of this Securable.
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this Securable.

        :return: The name of this Securable.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Securable.

        :param name: The name of this Securable.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def roles(self):
        """
        Gets the roles of this Securable.

        :return: The roles of this Securable.
        :rtype: list[ResourceBase]
        """
        return self._roles

    @roles.setter
    def roles(self, roles):
        """
        Sets the roles of this Securable.

        :param roles: The roles of this Securable.
        :type: list[ResourceBase]
        """

        self._roles = roles

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Securable):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
