# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import models into model package
from .add_group_auth_z_subscription_request import AddGroupAuthZSubscriptionRequest
from .add_on import AddOn
from .add_on_container import AddOnContainer
from .add_on_instances_container import AddOnInstancesContainer
from .add_on_parameter import AddOnParameter
from .add_on_parameter_definition import AddOnParameterDefinition
from .add_user_auth_z_subscription_request import AddUserAuthZSubscriptionRequest
from .aggregate_application_allocation_dto import AggregateApplicationAllocationDTO
from .aggregate_log_data import AggregateLogData
from .application import Application
from .byte_array_content import ByteArrayContent
from .cache_node import CacheNode
from .certificate import Certificate
from .cloud import Cloud
from .cloud_reference import CloudReference
from .component import Component
from .component_instance_holder import ComponentInstanceHolder
from .component_reference import ComponentReference
from .component_resource import ComponentResource
from .context import Context
from .custom_property import CustomProperty
from .custom_property_model import CustomPropertyModel
from .custom_url_certificate import CustomUrlCertificate
from .debug_connection import DebugConnection
from .deployed_add_on import DeployedAddOn
from .deployed_add_on_reference import DeployedAddOnReference
from .enhanced_add_on import EnhancedAddOn
from .enriched_application import EnrichedApplication
from .enriched_component import EnrichedComponent
from .enriched_component_model import EnrichedComponentModel
from .enriched_resource_allocation_policy import EnrichedResourceAllocationPolicy
from .enriched_storage_quota import EnrichedStorageQuota
from .enriched_version import EnrichedVersion
from .environment_variable_data import EnvironmentVariableData
from .jmx_connection import JMXConnection
from .java_container_dto import JavaContainerDTO
from .java_runtime_return import JavaRuntimeReturn
from .key_value_pair_string_i_enumerable_string import KeyValuePairStringIEnumerableString
from .log_override import LogOverride
from .log_override_dto import LogOverrideDTO
from .log_override_email_recipient_dto import LogOverrideEmailRecipientDTO
from .log_override_repeat_aggregation_settings import LogOverrideRepeatAggregationSettings
from .log_override_subscriber import LogOverrideSubscriber
from .log_override_user import LogOverrideUser
from .minimal_custom_url_certificate import MinimalCustomUrlCertificate
from .monitoring_connection_details_dto import MonitoringConnectionDetailsDTO
from .monitoring_subscription import MonitoringSubscription
from .name_value_pair import NameValuePair
from .override_tenant_info_dto import OverrideTenantInfoDTO
from .override_user_info_dto import OverrideUserInfoDTO
from .paged_resource_base_subscribed_tenant import PagedResourceBaseSubscribedTenant
from .paged_resource_base_subscribed_user import PagedResourceBaseSubscribedUser
from .paged_resource_base_user import PagedResourceBaseUser
from .paged_resource_base_user_group import PagedResourceBaseUserGroup
from .plan import Plan
from .platform_log_override_dto import PlatformLogOverrideDTO
from .provision_add_on_options import ProvisionAddOnOptions
from .registry_setting_base import RegistrySettingBase
from .remove_group_auth_z_subscription_request import RemoveGroupAuthZSubscriptionRequest
from .remove_user_auth_z_subscription_request import RemoveUserAuthZSubscriptionRequest
from .report_card import ReportCard
from .report_card_message import ReportCardMessage
from .report_card_section import ReportCardSection
from .resource_allocation_policy import ResourceAllocationPolicy
from .resource_allocation_policy_reference import ResourceAllocationPolicyReference
from .resource_base import ResourceBase
from .scheduled_scaling_event import ScheduledScalingEvent
from .securable_access import SecurableAccess
from .storage_quota import StorageQuota
from .storage_quota_reference import StorageQuotaReference
from .subscribed_tenant import SubscribedTenant
from .subscribed_user import SubscribedUser
from .subscription import Subscription
from .subscription_request import SubscriptionRequest
from .unpaged_resource_base_component import UnpagedResourceBaseComponent
from .unpaged_resource_base_name_value_pair import UnpagedResourceBaseNameValuePair
from .unpaged_resource_base_plan import UnpagedResourceBasePlan
from .unpaged_resource_base_subscription import UnpagedResourceBaseSubscription
from .upgrade_status import UpgradeStatus
from .user import User
from .user_group import UserGroup
from .utilization_aggregate import UtilizationAggregate
from .version import Version
from .workload import Workload
