# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Context(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, tenant_selection_page_url=None, user_has_multiple_entitlements=None, user=None, user_email=None, tenant_alias=None, href=None):
        """
        Context - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tenant_selection_page_url': 'str',
            'user_has_multiple_entitlements': 'bool',
            'user': 'str',
            'user_email': 'str',
            'tenant_alias': 'str',
            'href': 'str'
        }

        self.attribute_map = {
            'tenant_selection_page_url': 'tenantSelectionPageUrl',
            'user_has_multiple_entitlements': 'userHasMultipleEntitlements',
            'user': 'user',
            'user_email': 'userEmail',
            'tenant_alias': 'tenantAlias',
            'href': 'href'
        }

        self._tenant_selection_page_url = tenant_selection_page_url
        self._user_has_multiple_entitlements = user_has_multiple_entitlements
        self._user = user
        self._user_email = user_email
        self._tenant_alias = tenant_alias
        self._href = href

    @property
    def tenant_selection_page_url(self):
        """
        Gets the tenant_selection_page_url of this Context.

        :return: The tenant_selection_page_url of this Context.
        :rtype: str
        """
        return self._tenant_selection_page_url

    @tenant_selection_page_url.setter
    def tenant_selection_page_url(self, tenant_selection_page_url):
        """
        Sets the tenant_selection_page_url of this Context.

        :param tenant_selection_page_url: The tenant_selection_page_url of this Context.
        :type: str
        """

        self._tenant_selection_page_url = tenant_selection_page_url

    @property
    def user_has_multiple_entitlements(self):
        """
        Gets the user_has_multiple_entitlements of this Context.

        :return: The user_has_multiple_entitlements of this Context.
        :rtype: bool
        """
        return self._user_has_multiple_entitlements

    @user_has_multiple_entitlements.setter
    def user_has_multiple_entitlements(self, user_has_multiple_entitlements):
        """
        Sets the user_has_multiple_entitlements of this Context.

        :param user_has_multiple_entitlements: The user_has_multiple_entitlements of this Context.
        :type: bool
        """

        self._user_has_multiple_entitlements = user_has_multiple_entitlements

    @property
    def user(self):
        """
        Gets the user of this Context.

        :return: The user of this Context.
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """
        Sets the user of this Context.

        :param user: The user of this Context.
        :type: str
        """

        self._user = user

    @property
    def user_email(self):
        """
        Gets the user_email of this Context.

        :return: The user_email of this Context.
        :rtype: str
        """
        return self._user_email

    @user_email.setter
    def user_email(self, user_email):
        """
        Sets the user_email of this Context.

        :param user_email: The user_email of this Context.
        :type: str
        """

        self._user_email = user_email

    @property
    def tenant_alias(self):
        """
        Gets the tenant_alias of this Context.

        :return: The tenant_alias of this Context.
        :rtype: str
        """
        return self._tenant_alias

    @tenant_alias.setter
    def tenant_alias(self, tenant_alias):
        """
        Sets the tenant_alias of this Context.

        :param tenant_alias: The tenant_alias of this Context.
        :type: str
        """

        self._tenant_alias = tenant_alias

    @property
    def href(self):
        """
        Gets the href of this Context.

        :return: The href of this Context.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this Context.

        :param href: The href of this Context.
        :type: str
        """

        self._href = href

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Context):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
