# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class MinimalCustomUrlCertificate(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, valid_after=None, valid_before=None, subject=None, href=None):
        """
        MinimalCustomUrlCertificate - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'valid_after': 'datetime',
            'valid_before': 'datetime',
            'subject': 'str',
            'href': 'str'
        }

        self.attribute_map = {
            'valid_after': 'validAfter',
            'valid_before': 'validBefore',
            'subject': 'subject',
            'href': 'href'
        }

        self._valid_after = valid_after
        self._valid_before = valid_before
        self._subject = subject
        self._href = href

    @property
    def valid_after(self):
        """
        Gets the valid_after of this MinimalCustomUrlCertificate.

        :return: The valid_after of this MinimalCustomUrlCertificate.
        :rtype: datetime
        """
        return self._valid_after

    @valid_after.setter
    def valid_after(self, valid_after):
        """
        Sets the valid_after of this MinimalCustomUrlCertificate.

        :param valid_after: The valid_after of this MinimalCustomUrlCertificate.
        :type: datetime
        """

        self._valid_after = valid_after

    @property
    def valid_before(self):
        """
        Gets the valid_before of this MinimalCustomUrlCertificate.

        :return: The valid_before of this MinimalCustomUrlCertificate.
        :rtype: datetime
        """
        return self._valid_before

    @valid_before.setter
    def valid_before(self, valid_before):
        """
        Sets the valid_before of this MinimalCustomUrlCertificate.

        :param valid_before: The valid_before of this MinimalCustomUrlCertificate.
        :type: datetime
        """

        self._valid_before = valid_before

    @property
    def subject(self):
        """
        Gets the subject of this MinimalCustomUrlCertificate.

        :return: The subject of this MinimalCustomUrlCertificate.
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """
        Sets the subject of this MinimalCustomUrlCertificate.

        :param subject: The subject of this MinimalCustomUrlCertificate.
        :type: str
        """

        self._subject = subject

    @property
    def href(self):
        """
        Gets the href of this MinimalCustomUrlCertificate.

        :return: The href of this MinimalCustomUrlCertificate.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this MinimalCustomUrlCertificate.

        :param href: The href of this MinimalCustomUrlCertificate.
        :type: str
        """

        self._href = href

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, MinimalCustomUrlCertificate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
