# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class MonitoringSubscription(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, locator=None, component=None, update_interval=None, properties=None, href=None):
        """
        MonitoringSubscription - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'locator': 'str',
            'component': 'ComponentReference',
            'update_interval': 'int',
            'properties': 'list[str]',
            'href': 'str'
        }

        self.attribute_map = {
            'locator': 'locator',
            'component': 'component',
            'update_interval': 'updateInterval',
            'properties': 'properties',
            'href': 'href'
        }

        self._locator = locator
        self._component = component
        self._update_interval = update_interval
        self._properties = properties
        self._href = href

    @property
    def locator(self):
        """
        Gets the locator of this MonitoringSubscription.

        :return: The locator of this MonitoringSubscription.
        :rtype: str
        """
        return self._locator

    @locator.setter
    def locator(self, locator):
        """
        Sets the locator of this MonitoringSubscription.

        :param locator: The locator of this MonitoringSubscription.
        :type: str
        """

        self._locator = locator

    @property
    def component(self):
        """
        Gets the component of this MonitoringSubscription.

        :return: The component of this MonitoringSubscription.
        :rtype: ComponentReference
        """
        return self._component

    @component.setter
    def component(self, component):
        """
        Sets the component of this MonitoringSubscription.

        :param component: The component of this MonitoringSubscription.
        :type: ComponentReference
        """

        self._component = component

    @property
    def update_interval(self):
        """
        Gets the update_interval of this MonitoringSubscription.

        :return: The update_interval of this MonitoringSubscription.
        :rtype: int
        """
        return self._update_interval

    @update_interval.setter
    def update_interval(self, update_interval):
        """
        Sets the update_interval of this MonitoringSubscription.

        :param update_interval: The update_interval of this MonitoringSubscription.
        :type: int
        """

        self._update_interval = update_interval

    @property
    def properties(self):
        """
        Gets the properties of this MonitoringSubscription.

        :return: The properties of this MonitoringSubscription.
        :rtype: list[str]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """
        Sets the properties of this MonitoringSubscription.

        :param properties: The properties of this MonitoringSubscription.
        :type: list[str]
        """

        self._properties = properties

    @property
    def href(self):
        """
        Gets the href of this MonitoringSubscription.

        :return: The href of this MonitoringSubscription.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this MonitoringSubscription.

        :param href: The href of this MonitoringSubscription.
        :type: str
        """

        self._href = href

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, MonitoringSubscription):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
