# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Plan(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, id=None, href=None, name=None, entitlement_name=None, entitlement_defintion_type=None):
        """
        Plan - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'href': 'str',
            'name': 'str',
            'entitlement_name': 'str',
            'entitlement_defintion_type': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'href': 'href',
            'name': 'name',
            'entitlement_name': 'entitlementName',
            'entitlement_defintion_type': 'entitlementDefintionType'
        }

        self._id = id
        self._href = href
        self._name = name
        self._entitlement_name = entitlement_name
        self._entitlement_defintion_type = entitlement_defintion_type

    @property
    def id(self):
        """
        Gets the id of this Plan.

        :return: The id of this Plan.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Plan.

        :param id: The id of this Plan.
        :type: str
        """

        self._id = id

    @property
    def href(self):
        """
        Gets the href of this Plan.

        :return: The href of this Plan.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this Plan.

        :param href: The href of this Plan.
        :type: str
        """

        self._href = href

    @property
    def name(self):
        """
        Gets the name of this Plan.

        :return: The name of this Plan.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Plan.

        :param name: The name of this Plan.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def entitlement_name(self):
        """
        Gets the entitlement_name of this Plan.

        :return: The entitlement_name of this Plan.
        :rtype: str
        """
        return self._entitlement_name

    @entitlement_name.setter
    def entitlement_name(self, entitlement_name):
        """
        Sets the entitlement_name of this Plan.

        :param entitlement_name: The entitlement_name of this Plan.
        :type: str
        """

        self._entitlement_name = entitlement_name

    @property
    def entitlement_defintion_type(self):
        """
        Gets the entitlement_defintion_type of this Plan.

        :return: The entitlement_defintion_type of this Plan.
        :rtype: str
        """
        return self._entitlement_defintion_type

    @entitlement_defintion_type.setter
    def entitlement_defintion_type(self, entitlement_defintion_type):
        """
        Sets the entitlement_defintion_type of this Plan.

        :param entitlement_defintion_type: The entitlement_defintion_type of this Plan.
        :type: str
        """
        allowed_values = ["UserBased", "AccountWide"]
        if entitlement_defintion_type not in allowed_values:
            raise ValueError(
                "Invalid value for `entitlement_defintion_type` ({0}), must be one of {1}"
                .format(entitlement_defintion_type, allowed_values)
            )

        self._entitlement_defintion_type = entitlement_defintion_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Plan):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
