# coding: utf-8

"""
    Apprenda.DeveloperPortal.Web

    The Application Management REST API can be leveraged to customize the Developer experience of deploying and managing applications  on the Apprenda Platform. This allows some of the functionality of the Platform's [Developer Portal](/current/developer-portal)to be accomplished through a variety of means such as custom-built UX or command-line interfaces.     ##Authentication    Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/appmanagement/v1/authentication).    ##Making a Request    ###Prerequisites    * Installed Platform of version 4.5.0 or later     * Authentication token     * To use this API you must be part of a [Development Team or Tenant](/current/create-users) and have an [active subscription](/current/dev-portal-setup#create) to Developer Portal    ###Request URL    All requests must use **https**.    The URL for every request you make is the Cloud URI of your Platform followed by \"/developer\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/developer/api/v1/addons**.      For more information, see our documentation on [using API resources](/restapi/appmanagement/v1/resources) and [finding your Cloud URI](/current/clouduri).

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ReportCard(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, success=None, begin_date=None, end_date=None, status=None, sections=None):
        """
        ReportCard - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'success': 'bool',
            'begin_date': 'datetime',
            'end_date': 'datetime',
            'status': 'str',
            'sections': 'list[ReportCardSection]'
        }

        self.attribute_map = {
            'success': 'success',
            'begin_date': 'beginDate',
            'end_date': 'endDate',
            'status': 'status',
            'sections': 'sections'
        }

        self._success = success
        self._begin_date = begin_date
        self._end_date = end_date
        self._status = status
        self._sections = sections

    @property
    def success(self):
        """
        Gets the success of this ReportCard.

        :return: The success of this ReportCard.
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """
        Sets the success of this ReportCard.

        :param success: The success of this ReportCard.
        :type: bool
        """

        self._success = success

    @property
    def begin_date(self):
        """
        Gets the begin_date of this ReportCard.

        :return: The begin_date of this ReportCard.
        :rtype: datetime
        """
        return self._begin_date

    @begin_date.setter
    def begin_date(self, begin_date):
        """
        Sets the begin_date of this ReportCard.

        :param begin_date: The begin_date of this ReportCard.
        :type: datetime
        """

        self._begin_date = begin_date

    @property
    def end_date(self):
        """
        Gets the end_date of this ReportCard.

        :return: The end_date of this ReportCard.
        :rtype: datetime
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """
        Sets the end_date of this ReportCard.

        :param end_date: The end_date of this ReportCard.
        :type: datetime
        """

        self._end_date = end_date

    @property
    def status(self):
        """
        Gets the status of this ReportCard.

        :return: The status of this ReportCard.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this ReportCard.

        :param status: The status of this ReportCard.
        :type: str
        """
        allowed_values = ["Started", "Succeeded", "Failed", "Canceled"]
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def sections(self):
        """
        Gets the sections of this ReportCard.

        :return: The sections of this ReportCard.
        :rtype: list[ReportCardSection]
        """
        return self._sections

    @sections.setter
    def sections(self, sections):
        """
        Sets the sections of this ReportCard.

        :param sections: The sections of this ReportCard.
        :type: list[ReportCardSection]
        """

        self._sections = sections

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ReportCard):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
