# coding: utf-8

"""
    Platform Operations Rest API

    The Platform Operations REST API can be leveraged to customize the Platform Operator experience of managing infrastructure and applications for the Apprenda Platform. This allows some of the functionality of the Platform's System Operations Center (SOC) to be accomplished through a variety of means such as custom-built UX or command-line interfaces.   For more information about the abilities of Platform Operators, see our documentation on the [SOC](/current/SOC).   ##Authentication   Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/platformops/v1/authentication).   ##Making a Request   ###Prerequisites   * Installed Platform of version 6.5.1 or later (Note that most endpoints are only available in version 6.7.0 and later)    * Authentication token   * If SOC authorization is enabled on your Platform, you must be assigned as an active Platform Operator   ###Request URL   All requests must use **https**.   The URL for every request you make is the Cloud URI of your Platform followed by \"/soc\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/soc/api/v1/addons**.   For more information, see our documentation on [using API resources](/restapi/platformops/v1/using-resources) and [finding your Cloud URI](/current/clouduri).   ###Request Headers   Your authenication token must be passed in the header of all requests using the key **ApprendaSessionToken** (not case sensitive).  

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Cluster(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, url=None, cloudid=None, username=None, password=None, gatewayhostnames=None, href=None):
        """
        Cluster - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'url': 'str',
            'cloudid': 'int',
            'username': 'str',
            'password': 'str',
            'gatewayhostnames': 'str',
            'href': 'str'
        }

        self.attribute_map = {
            'name': 'name',
            'url': 'url',
            'cloudid': 'cloudid',
            'username': 'username',
            'password': 'password',
            'gatewayhostnames': 'gatewayhostnames',
            'href': 'href'
        }

        self._name = name
        self._url = url
        self._cloudid = cloudid
        self._username = username
        self._password = password
        self._gatewayhostnames = gatewayhostnames
        self._href = href

    @property
    def name(self):
        """
        Gets the name of this Cluster.

        :return: The name of this Cluster.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Cluster.

        :param name: The name of this Cluster.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def url(self):
        """
        Gets the url of this Cluster.

        :return: The url of this Cluster.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this Cluster.

        :param url: The url of this Cluster.
        :type: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")

        self._url = url

    @property
    def cloudid(self):
        """
        Gets the cloudid of this Cluster.

        :return: The cloudid of this Cluster.
        :rtype: int
        """
        return self._cloudid

    @cloudid.setter
    def cloudid(self, cloudid):
        """
        Sets the cloudid of this Cluster.

        :param cloudid: The cloudid of this Cluster.
        :type: int
        """
        if cloudid is None:
            raise ValueError("Invalid value for `cloudid`, must not be `None`")

        self._cloudid = cloudid

    @property
    def username(self):
        """
        Gets the username of this Cluster.

        :return: The username of this Cluster.
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """
        Sets the username of this Cluster.

        :param username: The username of this Cluster.
        :type: str
        """
        if username is None:
            raise ValueError("Invalid value for `username`, must not be `None`")

        self._username = username

    @property
    def password(self):
        """
        Gets the password of this Cluster.

        :return: The password of this Cluster.
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """
        Sets the password of this Cluster.

        :param password: The password of this Cluster.
        :type: str
        """
        if password is None:
            raise ValueError("Invalid value for `password`, must not be `None`")

        self._password = password

    @property
    def gatewayhostnames(self):
        """
        Gets the gatewayhostnames of this Cluster.

        :return: The gatewayhostnames of this Cluster.
        :rtype: str
        """
        return self._gatewayhostnames

    @gatewayhostnames.setter
    def gatewayhostnames(self, gatewayhostnames):
        """
        Sets the gatewayhostnames of this Cluster.

        :param gatewayhostnames: The gatewayhostnames of this Cluster.
        :type: str
        """
        if gatewayhostnames is None:
            raise ValueError("Invalid value for `gatewayhostnames`, must not be `None`")

        self._gatewayhostnames = gatewayhostnames

    @property
    def href(self):
        """
        Gets the href of this Cluster.

        :return: The href of this Cluster.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this Cluster.

        :param href: The href of this Cluster.
        :type: str
        """

        self._href = href

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Cluster):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
