# coding: utf-8

"""
    Platform Operations Rest API

    The Platform Operations REST API can be leveraged to customize the Platform Operator experience of managing infrastructure and applications for the Apprenda Platform. This allows some of the functionality of the Platform's System Operations Center (SOC) to be accomplished through a variety of means such as custom-built UX or command-line interfaces.   For more information about the abilities of Platform Operators, see our documentation on the [SOC](/current/SOC).   ##Authentication   Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/platformops/v1/authentication).   ##Making a Request   ###Prerequisites   * Installed Platform of version 6.5.1 or later (Note that most endpoints are only available in version 6.7.0 and later)    * Authentication token   * If SOC authorization is enabled on your Platform, you must be assigned as an active Platform Operator   ###Request URL   All requests must use **https**.   The URL for every request you make is the Cloud URI of your Platform followed by \"/soc\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/soc/api/v1/addons**.   For more information, see our documentation on [using API resources](/restapi/platformops/v1/using-resources) and [finding your Cloud URI](/current/clouduri).   ###Request Headers   Your authenication token must be passed in the header of all requests using the key **ApprendaSessionToken** (not case sensitive).  

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CustomProperty(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, id=None, name=None, display_name=None, description=None, value_options=None, developer_options=None, applicability=None, href=None):
        """
        CustomProperty - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'int',
            'name': 'str',
            'display_name': 'str',
            'description': 'str',
            'value_options': 'CustomPropertyValueOptions',
            'developer_options': 'CustomPropertyDeveloperOptions',
            'applicability': 'CustomPropertyApplicabilityOptionCollection',
            'href': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'display_name': 'displayName',
            'description': 'description',
            'value_options': 'valueOptions',
            'developer_options': 'developerOptions',
            'applicability': 'applicability',
            'href': 'href'
        }

        self._id = id
        self._name = name
        self._display_name = display_name
        self._description = description
        self._value_options = value_options
        self._developer_options = developer_options
        self._applicability = applicability
        self._href = href

    @property
    def id(self):
        """
        Gets the id of this CustomProperty.

        :return: The id of this CustomProperty.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this CustomProperty.

        :param id: The id of this CustomProperty.
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this CustomProperty.

        :return: The name of this CustomProperty.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CustomProperty.

        :param name: The name of this CustomProperty.
        :type: str
        """

        self._name = name

    @property
    def display_name(self):
        """
        Gets the display_name of this CustomProperty.

        :return: The display_name of this CustomProperty.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this CustomProperty.

        :param display_name: The display_name of this CustomProperty.
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """
        Gets the description of this CustomProperty.

        :return: The description of this CustomProperty.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this CustomProperty.

        :param description: The description of this CustomProperty.
        :type: str
        """

        self._description = description

    @property
    def value_options(self):
        """
        Gets the value_options of this CustomProperty.

        :return: The value_options of this CustomProperty.
        :rtype: CustomPropertyValueOptions
        """
        return self._value_options

    @value_options.setter
    def value_options(self, value_options):
        """
        Sets the value_options of this CustomProperty.

        :param value_options: The value_options of this CustomProperty.
        :type: CustomPropertyValueOptions
        """

        self._value_options = value_options

    @property
    def developer_options(self):
        """
        Gets the developer_options of this CustomProperty.

        :return: The developer_options of this CustomProperty.
        :rtype: CustomPropertyDeveloperOptions
        """
        return self._developer_options

    @developer_options.setter
    def developer_options(self, developer_options):
        """
        Sets the developer_options of this CustomProperty.

        :param developer_options: The developer_options of this CustomProperty.
        :type: CustomPropertyDeveloperOptions
        """

        self._developer_options = developer_options

    @property
    def applicability(self):
        """
        Gets the applicability of this CustomProperty.

        :return: The applicability of this CustomProperty.
        :rtype: CustomPropertyApplicabilityOptionCollection
        """
        return self._applicability

    @applicability.setter
    def applicability(self, applicability):
        """
        Sets the applicability of this CustomProperty.

        :param applicability: The applicability of this CustomProperty.
        :type: CustomPropertyApplicabilityOptionCollection
        """

        self._applicability = applicability

    @property
    def href(self):
        """
        Gets the href of this CustomProperty.

        :return: The href of this CustomProperty.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this CustomProperty.

        :param href: The href of this CustomProperty.
        :type: str
        """

        self._href = href

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CustomProperty):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
