# coding: utf-8

"""
    Platform Operations Rest API

    The Platform Operations REST API can be leveraged to customize the Platform Operator experience of managing infrastructure and applications for the Apprenda Platform. This allows some of the functionality of the Platform's System Operations Center (SOC) to be accomplished through a variety of means such as custom-built UX or command-line interfaces.   For more information about the abilities of Platform Operators, see our documentation on the [SOC](/current/SOC).   ##Authentication   Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/platformops/v1/authentication).   ##Making a Request   ###Prerequisites   * Installed Platform of version 6.5.1 or later (Note that most endpoints are only available in version 6.7.0 and later)    * Authentication token   * If SOC authorization is enabled on your Platform, you must be assigned as an active Platform Operator   ###Request URL   All requests must use **https**.   The URL for every request you make is the Cloud URI of your Platform followed by \"/soc\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/soc/api/v1/addons**.   For more information, see our documentation on [using API resources](/restapi/platformops/v1/using-resources) and [finding your Cloud URI](/current/clouduri).   ###Request Headers   Your authenication token must be passed in the header of all requests using the key **ApprendaSessionToken** (not case sensitive).  

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CustomPropertyApplicationComponentOptions(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, user_interfaces=None, java_web_applications=None, windows_services=None, linux_services=None, databases=None):
        """
        CustomPropertyApplicationComponentOptions - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'user_interfaces': 'bool',
            'java_web_applications': 'bool',
            'windows_services': 'bool',
            'linux_services': 'bool',
            'databases': 'bool'
        }

        self.attribute_map = {
            'user_interfaces': 'userInterfaces',
            'java_web_applications': 'javaWebApplications',
            'windows_services': 'windowsServices',
            'linux_services': 'linuxServices',
            'databases': 'databases'
        }

        self._user_interfaces = user_interfaces
        self._java_web_applications = java_web_applications
        self._windows_services = windows_services
        self._linux_services = linux_services
        self._databases = databases

    @property
    def user_interfaces(self):
        """
        Gets the user_interfaces of this CustomPropertyApplicationComponentOptions.

        :return: The user_interfaces of this CustomPropertyApplicationComponentOptions.
        :rtype: bool
        """
        return self._user_interfaces

    @user_interfaces.setter
    def user_interfaces(self, user_interfaces):
        """
        Sets the user_interfaces of this CustomPropertyApplicationComponentOptions.

        :param user_interfaces: The user_interfaces of this CustomPropertyApplicationComponentOptions.
        :type: bool
        """

        self._user_interfaces = user_interfaces

    @property
    def java_web_applications(self):
        """
        Gets the java_web_applications of this CustomPropertyApplicationComponentOptions.

        :return: The java_web_applications of this CustomPropertyApplicationComponentOptions.
        :rtype: bool
        """
        return self._java_web_applications

    @java_web_applications.setter
    def java_web_applications(self, java_web_applications):
        """
        Sets the java_web_applications of this CustomPropertyApplicationComponentOptions.

        :param java_web_applications: The java_web_applications of this CustomPropertyApplicationComponentOptions.
        :type: bool
        """

        self._java_web_applications = java_web_applications

    @property
    def windows_services(self):
        """
        Gets the windows_services of this CustomPropertyApplicationComponentOptions.

        :return: The windows_services of this CustomPropertyApplicationComponentOptions.
        :rtype: bool
        """
        return self._windows_services

    @windows_services.setter
    def windows_services(self, windows_services):
        """
        Sets the windows_services of this CustomPropertyApplicationComponentOptions.

        :param windows_services: The windows_services of this CustomPropertyApplicationComponentOptions.
        :type: bool
        """

        self._windows_services = windows_services

    @property
    def linux_services(self):
        """
        Gets the linux_services of this CustomPropertyApplicationComponentOptions.

        :return: The linux_services of this CustomPropertyApplicationComponentOptions.
        :rtype: bool
        """
        return self._linux_services

    @linux_services.setter
    def linux_services(self, linux_services):
        """
        Sets the linux_services of this CustomPropertyApplicationComponentOptions.

        :param linux_services: The linux_services of this CustomPropertyApplicationComponentOptions.
        :type: bool
        """

        self._linux_services = linux_services

    @property
    def databases(self):
        """
        Gets the databases of this CustomPropertyApplicationComponentOptions.

        :return: The databases of this CustomPropertyApplicationComponentOptions.
        :rtype: bool
        """
        return self._databases

    @databases.setter
    def databases(self, databases):
        """
        Sets the databases of this CustomPropertyApplicationComponentOptions.

        :param databases: The databases of this CustomPropertyApplicationComponentOptions.
        :type: bool
        """

        self._databases = databases

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CustomPropertyApplicationComponentOptions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
