# coding: utf-8

"""
    Platform Operations Rest API

    The Platform Operations REST API can be leveraged to customize the Platform Operator experience of managing infrastructure and applications for the Apprenda Platform. This allows some of the functionality of the Platform's System Operations Center (SOC) to be accomplished through a variety of means such as custom-built UX or command-line interfaces.   For more information about the abilities of Platform Operators, see our documentation on the [SOC](/current/SOC).   ##Authentication   Before making a request, you must be authenticated. Learn how to [get authenticated](/restapi/platformops/v1/authentication).   ##Making a Request   ###Prerequisites   * Installed Platform of version 6.5.1 or later (Note that most endpoints are only available in version 6.7.0 and later)    * Authentication token   * If SOC authorization is enabled on your Platform, you must be assigned as an active Platform Operator   ###Request URL   All requests must use **https**.   The URL for every request you make is the Cloud URI of your Platform followed by \"/soc\" and the path structure of the endpoint. For example, if your Cloud URI is apps.apprenda.harp and you want to get the Add-ons for your Platform, the request URI will be **apps.apprenda.harp/soc/api/v1/addons**.   For more information, see our documentation on [using API resources](/restapi/platformops/v1/using-resources) and [finding your Cloud URI](/current/clouduri).   ###Request Headers   Your authenication token must be passed in the header of all requests using the key **ApprendaSessionToken** (not case sensitive).  

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RegistrySetting(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, value=None, is_encrypted=None, is_read_only=None, href=None):
        """
        RegistrySetting - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'value': 'str',
            'is_encrypted': 'bool',
            'is_read_only': 'bool',
            'href': 'str'
        }

        self.attribute_map = {
            'name': 'name',
            'value': 'value',
            'is_encrypted': 'isEncrypted',
            'is_read_only': 'isReadOnly',
            'href': 'href'
        }

        self._name = name
        self._value = value
        self._is_encrypted = is_encrypted
        self._is_read_only = is_read_only
        self._href = href

    @property
    def name(self):
        """
        Gets the name of this RegistrySetting.

        :return: The name of this RegistrySetting.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this RegistrySetting.

        :param name: The name of this RegistrySetting.
        :type: str
        """

        self._name = name

    @property
    def value(self):
        """
        Gets the value of this RegistrySetting.

        :return: The value of this RegistrySetting.
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Sets the value of this RegistrySetting.

        :param value: The value of this RegistrySetting.
        :type: str
        """

        self._value = value

    @property
    def is_encrypted(self):
        """
        Gets the is_encrypted of this RegistrySetting.

        :return: The is_encrypted of this RegistrySetting.
        :rtype: bool
        """
        return self._is_encrypted

    @is_encrypted.setter
    def is_encrypted(self, is_encrypted):
        """
        Sets the is_encrypted of this RegistrySetting.

        :param is_encrypted: The is_encrypted of this RegistrySetting.
        :type: bool
        """

        self._is_encrypted = is_encrypted

    @property
    def is_read_only(self):
        """
        Gets the is_read_only of this RegistrySetting.

        :return: The is_read_only of this RegistrySetting.
        :rtype: bool
        """
        return self._is_read_only

    @is_read_only.setter
    def is_read_only(self, is_read_only):
        """
        Sets the is_read_only of this RegistrySetting.

        :param is_read_only: The is_read_only of this RegistrySetting.
        :type: bool
        """

        self._is_read_only = is_read_only

    @property
    def href(self):
        """
        Gets the href of this RegistrySetting.

        :return: The href of this RegistrySetting.
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """
        Sets the href of this RegistrySetting.

        :param href: The href of this RegistrySetting.
        :type: str
        """

        self._href = href

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RegistrySetting):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
